import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.NoSuchPortException;
import gnu.io.PortInUseException;
import gnu.io.SerialPortEventListener;
import gnu.io.SerialPortEvent;
import gnu.io.UnsupportedCommOperationException;
import java.io.*;

public class SomeClass {
  public static void main(String[] args){
    new SomeClass();
  }
  
  public SomeClass(){
    openSerialPort();
    try {
      port.addEventListener(new SerialPortEventListener(){
          public void serialEvent(SerialPortEvent ev){
            System.out.println(ev);
            if (ev.getEventType() == SerialPortEvent.DATA_AVAILABLE) {
              read();
            }
          }
      });
      port.notifyOnDataAvailable(true);
    } catch (Exception e){
      e.printStackTrace();
    }
    
    setSerialPort();
    
  }
  
  boolean openSerialPort() {
    try {
      portId = CommPortIdentifier.getPortIdentifier("COM1");
      port = (SerialPort)portId.open("SomeClass", 2000);
    } catch (NoSuchPortException e) {
      e.printStackTrace();
      return false;
    } catch (PortInUseException e) {
      e.printStackTrace();
      return false;
    }
    return true;
  }
  CommPortIdentifier portId;
  SerialPort port;
  
  boolean setSerialPort() {
    try {
      port.setSerialPortParams(
        19200,                   // ʐMx[bps]
        SerialPort.DATABITS_8,   // f[^rbg
        SerialPort.STOPBITS_1,   // Xgbvrbg
        SerialPort.PARITY_NONE   // peB
        );
      port.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
    } catch (UnsupportedCommOperationException e) {
      e.printStackTrace();
      return false;
    }
    port.setDTR(true);
    port.setRTS(false);
    return true;
  }
  
  // public void read() {
  // try {
  // InputStream in = port.getInputStream();
  // byte[] buffer = new byte[1024];
  // while (true) {
  // int numRead = in.read(buffer);
  // if (numRead == -1) {
  // break;
  // } else if (numRead == 0) {
  // try {
  // Thread.sleep(200);
  // } catch (InterruptedException e) {
  // // 荞܂ĂȂ
  // }
  // }
  // // bufferǂݏo
  // System.out.println(numRead);
  // }
  // } catch (Exception e){
  // e.printStackTrace();
  // }
  // }
  public void read() {
    try {
      InputStream in = port.getInputStream();
      byte[] buffer = new byte[1024];
      int numRead = in.read(buffer);
      System.out.println(numRead);
    } catch (Exception e){
      e.printStackTrace();
    }
  }
}
